FUNCTION MakeHelp   && UDF - Create User Help Files
*-----------------------------------------------------------------------------
*-- Notes......: Creates Help files (.dbf, .dbt, .mdx) for FORM.GEN v1.1
*-- Files......: makehelp.str, makehelp.scr, makehelp.fmt, makehelp.dbf,
*-- ...........: makehelp.dbt, makehelp.mdx
*-----------------------------------------------------------------------------

   PRIVATE lc_escape, lc_dbf, esc, lc_makehlp, lc_message, lc_cursor,;
           lc_alias

   DO talkoff

   lc_catalog = SET("CATALOG")
   lc_cursor = SET("CURSOR")
   lc_safety = SET("SAFETY")
   lc_escape = SET("ESCAPE")
   lc_alias = ALIAS()
   ln_fcount = FLDCOUNT()

   SELECT 2 &&  So format file will not try to be invoked

   SAVE SCREEN TO makehelp

   SET CURSOR OFF
   SET CATALOG OFF
   SET ESCAPE OFF
   SET SAFETY OFF

   DEFINE WINDOW makehelp FROM  12,9 TO 18,69 DOUBLE
   ACTIVATE WINDOW makehelp

   CLEAR

   *-- Build Help file name
   lc_dbf = lc_alias
   IF LEN(lc_dbf) > 6
      lc_dbf = LEFT( lc_dbf, 6)
   ENDIF

   lc_dbf = lc_dbf +"_H"

   IF FILE( (lc_dbf + ".dbf") )

      lc_message = "Do you want to edit help for " + lc_alias+ " (Y/N)"
      lc_makehlp = "YES"

      @ 2, CENTER( lc_message,56) SAY lc_message GET lc_makehlp;
         PICTURE "@M YES,NO "

      SET CURSOR ON
      READ
      SET CURSOR OFF

      IF lc_makehlp = "NO"
         DO make_exit
         RETURN .T.
      ENDIF

      USE ( lc_dbf )
      COUNT TO ln_fldcnt

      IF ln_fcount <> ln_fldcnt        && Are the field counts the same

         *-- Check for a change in the structure
         SET ORDER TO fld_name

         SELECT (lc_alias)             && Original dbf call from the form

         COPY TO ___old STRUCTURE EXTENDED

         SELECT SELECT()
         USE ___old ALIAS OLD

         INDEX ON field_name TAG fld
         GO TOP

         SCAN
            IF .NOT. SEEK( field_name, lc_dbf)
               SELECT (lc_dbf)
               APPEND BLANK
               REPLACE fld_name WITH old->field_name
               SELECT old
            ENDIF
         ENDSCAN

         USE IN old                    && Close the work file
         ERASE ___old.dbf              && Remove temporary work files
         ERASE ___old.mdx

         SELECT (lc_dbf)               && Select the Help file again
         SET ORDER TO
      ENDIF
      GO TOP

   ELSE

      *-- Start Help file build process

      SELECT (lc_alias)                          && Go back to OPEN .dbf for the FORM

      COPY STRU EXTENDED TO ___temp
      USE ___temp IN 3
      SELECT 2

      USE Makehelp                               && Use the HELP file structure
      CLEAR

      @ 2,0
      @ 2,1 SAY " Creating: "+lc_dbf +" Help file"
      mv = INKEY(1)

      *-- Copy the Help structure to the new help file
      COPY STRUCTURE TO (lc_dbf)
      USE (lc_dbf) IN SELECT()

      *-- Add field names from data file into help file
      SELECT 3
      @ 2,0
      @ 2,1 SAY " Adding field names to "+lc_dbf +" from " + lc_alias
      mv = INKEY(1)

      SCAN WHILE .NOT. EOF()
         SELECT (lc_dbf)
         APPEND BLANK
         SELECT 3
         REPLACE &lc_dbf.->fld_name WITH field_name
      ENDSCAN

      *-- Index New help file by fld_name
      SELE (lc_dbf)

      SET TALK ON
      INDEX ON fld_name TAG fld_name
      SET TALK OFF

   ENDIF

   SELE (lc_dbf)
   mv = INKEY(1)
   SET ORDER TO
   GO TOP

   *-- Allow help builder to enter help text
   IF FILE("MAKEHELP.FMT")
      SET FORM TO Makehelp
   ENDIF
   SET MESSAGE TO "You can now enter your help text - CTRL-W to exit"
   EDIT
   SET FORM TO
   SET MESSAGE TO

   *-- Search for deleted records on exit of Editing Help
   LOCATE FOR DELETED()
   IF FOUND()
       ACTIVATE WINDOW makehelp
       @ 2,0
       @ 2,1 SAY "Removing deleted records"
       PACK
       DEACTIVATE WINDOW makehelp
   ENDIF

   *-- Clean up environment
   USE
   USE IN 3
   USE IN 2
   ERASE ___TEMP.DBF

   DO make_exit

RETURN .T.
*-- EOF: MakeHelp()


PROCEDURE Make_Exit && UDS - MakeHelp()
   SET SAFETY &lc_safety.
   SET ESCAPE &lc_escape.
   SET CURSOR &lc_cursor.
   SET TALK &zz_talk.
   SET CATALOG &lc_catalog.
   RELEASE WINDOW makehelp
   SET MESSAGE TO
   SELECT (lc_alias)
   DO talkon
   Enter = CHR( 13 )
   Home  = CHR( 26 )
   CtrlY = CHR( 25 )
   KEYBOARD Enter + Home + CtrlY + Enter CLEAR
RETURN
*-- EOP: Make_Exit

