PROCEDURE Template
PARAMETERS pc_surface, pc_file
*----------------------------------------------------------------------------
* DESCRIPTION
*   Template will display the available .GEN files for the given design
*   surface using a popup.  The current template has a check mark in
*   the ACTIVE field.  Template displays the GEN files using the value
*   of <pc_surface>.  This value is stored in the DBASE_NAME field in
*   Template.DBF.  If the GEN files or Template.DBF are not in the
*   current directory, Template will check the dBASE HOME() directory.
*
*   The Del key will remove the record from the popup.  Template will
*   mark the record for deletion and rebuild the popup with SET DELETE
*   ON.  Selecting the <Add new GEN file> bar will allow you to add
*   a new GEN file for the surface.
* 
*   Structure for database : template.dbf
*   Number of data records : 10
*   Date of last update    : 07/16/91
*   Field  Field Name  Type       Width    Dec
*       1  ACTIVE      Character      1
*       2  WORK_NAME   Character     12
*       3  DBASE_NAME  Character      6
*       4  DESCRIPT    Character     32
*   ** Total **                   00052
*----------------------------------------------------------------------------
  PRIVATE ll_tfound, ln_bars, lc_prefix, ll_delete
  PRIVATE gl_react, ll_safety

  ll_safety = SET( "SAFETY" ) = "ON"
  SET SAFETY OFF

  ll_tfound = .F.
  ln_bars = 0
  ll_delete = SET( "DELETE" ) = "ON"

  IF FILE( "Template.DBF" )
    lc_prefix = ""
    ll_tfound = .T.
  ELSE
    lc_prefix = HOME()
    IF FILE( lc_prefix + "Template.DBF" )
      ll_found = .T.
    ENDIF
  ENDIF
  IF ll_tfound
    SET DELETE ON
    lc_alias = ALIAS()                  && Capture the current ALIAS
    SELECT SELECT()                     && Grab an available workarea
    USE ( lc_prefix + "Template" )      && Open the template file
    SET FILTER TO Dbase_Name = pc_surface
    GO TOP

    DO Bld_Temp                         && Build the template popup

    gl_react = .T.
    DO WHILE gl_react
      gl_react = .F.
      ON KEY LABEL Del DO Del_Temp
      ACTIVATE POPUP Template
      IF gl_react
        DO Bld_Temp
      ENDIF      
      ON KEY LABEL Del
    ENDDO

    IF BAR() > 0
      IF FILE( lc_prefix + Work_Name )
        ln_rec = RECNO()
        COPY FILE ( lc_prefix + Work_Name ) TO ;
                  ( lc_prefix + TRIM( Dbase_Name ) + ".GEN" )
        BLANK ALL FIELDS Active
        GO ln_rec
        REPLACE Active WITH CHR(251)
      ELSE
        DO Err_Box WITH "File not found: " + lc_prefix + Work_Name
      ENDIF
    ENDIF

    *-- Restore back the environment
    RELEASE POPUP Template
    USE
    IF .NOT. ll_delete
      SET DELETE OFF
    ENDIF
    IF .NOT. ISBLANK( lc_alias )
      SELECT ( lc_alias )
    ENDIF

  ELSE
    DO Err_Box WITH "File does not exist: " + lc_prefix + "Template.DBF"
  ENDIF

  IF ll_safety
    SET SAFETY ON
  ENDIF

RETURN
*-- EOP: Template


PROCEDURE Bld_Temp
*----------------------------------------------------------------------------
* NAME
*   Bld_Temp - Build the template GEN popup
*
*----------------------------------------------------------------------------
  PRIVATE ln_bars

  SET BORDER TO DOUBLE
  DEFINE POPUP Template FROM  5,11 TO 12, 65
  ON SELECTION POPUP Template DO Sel_Temp

  ln_bars = 1

  *-- Define the data bars
  SCAN
    DEFINE BAR ln_bars OF Template PROMPT;
      " " + Active + " " + CHR( 179 ) + ;
      " " + Work_Name + " " + CHR( 179 ) + ;
      " " + Descript + " "
    ln_bars = ln_bars + 1
  ENDSCAN

  *-- Define the append bar
  DEFINE BAR ln_bars OF Template PROMPT;
      " " + SPACE(1) + " " + CHR( 179 ) + ;
      " " + SPACE(12) + " " + CHR( 179 ) + ;
      " " + "<Add new GEN file>             " + " "
  ln_bars = ln_bars + 1

  *-- Define the remaining blank bars
  DO WHILE ln_bars < 7
    DEFINE BAR ln_bars OF Template PROMPT;
      " " + SPACE(1) + " " + CHR( 179 ) + ;
      " " + SPACE(12) + " " + CHR( 179 ) + ;
      " " + SPACE(32) + " " SKIP
    ln_bars = ln_bars + 1
  ENDDO

  SET BORDER TO

RETURN
*-- EOP: Bld_Temp

PROCEDURE Sel_Temp
PARAMETERS pn_bars
*----------------------------------------------------------------------------
* NAME
*   Sel_Temp - Position to the correct record or add one
*
*----------------------------------------------------------------------------
  PRIVATE ln_bar, ln_row, Active, Work_Name, Descript

  ON KEY LABEL Del

  ln_bar = BAR()
  ln_row = ROW()
  IF .NOT. "<Add new GEN file>" $ PROMPT()
    GO TOP
    SKIP ln_bar - 1
    DEACTIVATE POPUP
  ELSE
    GO TOP
    m->Work_Name = SPACE( 12 )
    m->Descript = SPACE( 32 )

    @ ln_row, 17 GET m->Work_Name ;
        MESSAGE "Enter in the name of the .GEN file including it's extension" 
    @ ln_row, 32 GET m->Descript ;
        MESSAGE "Enter in a description that represents the .GEN file"
    READ
    IF READKEY() > 255
      APPEND BLANK
      REPLACE Work_Name  WITH m->Work_Name, ;
              Dbase_Name WITH pc_surface, ;
              Descript   WITH m->Descript
      gl_react = .T.
      DEACTIVATE POPUP
    ENDIF
  ENDIF

RETURN
*-- EOP: Sel_Temp

PROCEDURE Del_Temp
  IF .NOT. "<Add new GEN file>" $ PROMPT()
    GO TOP
    SKIP BAR() - 1
    DELETE
    gl_react = .T.
    DEACTIVATE POPUP
  ENDIF
RETURN
*-- EOP: Del_Temp



